/*
* Mateusz Jurczak
* C++20 Modules
*/

/*
deklaracja nazwy modulu i jego eksportowanie (mozliwosc importowania tego
modulu w innych plikach)
*/
export module A;
/*
zaimportowanie modulu <vector>
naglowek nie zostanie wyeksportowany (importowanie modulu A nie zaimportuje
automatycznie tego naglowka)
*/
import <vector>;
/*
zaimportowanie modulu <iostream>
naglowek tym razem zostanie wyeksportowany (importowanie modulu A automatycznie
zaimportuje ten naglowek)
*/
export import <iostream>;

/*
deklaracja funkcji i zmiennej globalnej do eksportu (importowanie modulu A
umozliwi korzystanie z nich)
*/
export void moduleAExportedFunction();
export int moduleAGlobalVariable = 10;

// definicja eksportowanej funkcji
void moduleAExportedFunction() {
	std::cout << "A moduleAExportedFunction()\n";
}
// definicja funkcji nieoznaczonej do eksportu
void moduleANotExportedFunction() {
	std::cout << "A moduleANotExportedFunction()\n";
}

namespace ns1 {
	void func2();

	// mozna oznaczyc funkcje jako export przy jej definicji
	export void func1() {
		func2();
	}

	// ta funkcja nie jest eksportowana ale moze byc wowolana przez func1
	void func2() {
		// naglowek vector zostal zaimportowany
		std::vector<int> nums;
		for (int i = 0; i < 8; i++)
			nums.push_back(i);
		for (auto& num : nums) {
			num %= 3;
			std::cout << num;
		}
		std::cout << "\n";
	}
};

/*
eksportowanie przestrzeni nazw sprawia, ze wszystkie elementy w niej zawarte
zostana wyeksportowane bez koniecznosci oznaczania kazdego z nich jako export
*/
export namespace ns2 {
	void func1() {
		std::cout << "Exported namespace func1\n";
	}

	void func2() {
		std::cout << "Exported namespace func2\n";
	}
}
